﻿var timerID = null;
var runningRequest = null;
var isNetwork = false;
var bUpdating = false;
var URL = "http://informer.gismeteo.ru/xml/";
var currentTOD = 0;

//  tod время суток, для которого составлен прогноз: 0 - ночь 1 - утро, 2 - день, 3 - вечер 
// cloudiness облачность по градациям:  0 - ясно, 1- малооблачно, 2 - облачно, 3 - пасмурно 
//  precipitation тип осадков: 4 - дождь, 5 - ливень, 6,7 – снег, 8 - гроза, 9 - нет данных, 10 - без осадков 
var icons = new Array(/*0 - ночь */ ['night_01.png', 'night_02.png', 'night_03.png', 'night_04.png', 'night_05.png', 'night_06.png', 'night_07.png', 'night_08.png', 'night_09.png'],										 
					  /*1 - утро */ ['morning_01.png', 'morning_02.png', 'morning_03.png', 'morning_04.png', 'morning_05.png', 'morning_06.png', 'morning_07.png', 'morning_08.png', 'morning_09.png'],
					  /*2 - день */ ['day_01.png', 'day_02.png', 'day_03.png', 'day_04.png', 'day_05.png', 'day_06.png', 'day_07.png', 'day_08.png', 'day_09.png'],
					 /*3 - вечер */ ['evening_01.png', 'evening_02.png', 'evening_03.png', 'evening_04.png', 'evening_05.png', 'evening_06.png', 'evening_07.png', 'evening_08.png', 'evening_09.png']);

var tod_name = new Array('Ночь', 'Утро', 'День', 'Вечер');
var week_day = new Array('', 'Воскресенье', 'Понедельник', 'Вторник', 'Среда', 'Четверг', 'Пятница', 'Суббота');
var rssData = new Array();

function LoadWeatherForecast() {
	if (bNeedUpdate) {
		LoadXMLWeatherForecast();
	}
	else {		
        var xmlDom = getXmlDOM(userSettings.xmlText);
		ParseXML(xmlDom);
		currentTOD = 0;
		updateIdlePage(currentTOD);						
		document.getElementById('rightBtn').style.visibility = "visible";	
		document.getElementById('leftBtn').style.visibility = "hidden";		
		bNeedUpdate = false;
		bUpdating = false;		
	}	
}

function LoadXMLWeatherForecast() {
	if (bUpdating) return;
	
	if(window.widget) isNetwork = window.widget.sysInfo.network.getIsNetworkAvailable();
	else isNetwork = true;	
	
	if(!isNetwork) {
		showAccessError(); 	
		return;
	}
	
	try {
		bUpdating = true;
		showPopup('refresh', 55, 29);
		clearTimeout(timerID);
		timerID = null;
			
		var httpRequest = createXMLHttpRequest();
		runningRequest = httpRequest;
		httpRequest.onreadystatechange = function() {
			if (httpRequest.readyState == 4) {
				clearTimeout(timerID);
				timerID = null;
				
				if (httpRequest.status == 200) onLoadComplete(httpRequest.responseText);
				else showNetworkError();				
			}				
		}
		httpRequest.open('GET', URL+towns[userSettings.cityIndex][1]+'_1.xml', true);			
		httpRequest.send(null);			  
		timerID = setTimeout(function () { timeout(httpRequest); }, 90*1000);					
									  
	} catch(e) {
		clearTimeout(timerID);
		timerID = null;				
		bUpdating = false;
		showNetworkError(); 			
	}		
}

function createXMLHttpRequest() {		
		var xmlHttp = null; 
		try {
			xmlHttp = new XMLHttpRequest();
		} catch(e) {
			try {
				xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
			} catch(e) {
				try {
						xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
				} catch(e1) { }
			} 
		}
		return xmlHttp;			
}	

function onLoadComplete(xmlTxt) {
	try 
	{
		var xmlDom = getXmlDOM(xmlTxt);
		ParseXML(xmlDom);		
		
		currentTOD = 0;
		updateIdlePage(currentTOD);		
		
		document.getElementById('rightBtn').style.visibility = "visible";	
		document.getElementById('leftBtn').style.visibility = "hidden";	
		
		userSettings.saveXmlData(xmlTxt);
		bNeedUpdate = false;
		bUpdating = false;				
		hidePopup('refresh');		
	} 
	catch (e) {
		bUpdating = false;
		bNeedUpdate = false;
		showNetworkError(); 	
	}		
}

function updateIdlePage(tod) {	
	if (rssData[tod].precipitation > 3 && rssData[tod].precipitation < 9)
		large_icon.innerHTML = "<img src='images/"+icons[rssData[tod].tod][rssData[tod].precipitation]+"'></img>";	
	else
		large_icon.innerHTML = "<img src='images/"+icons[rssData[tod].tod][rssData[tod].cloudiness]+"'></img>";		
	

	cityName1.innerHTML   = towns[userSettings.cityIndex][0];
	weatherInfo.innerHTML = getTEMPtext(rssData[tod].minTEMP, rssData[tod].maxTEMP);		
	dateTxt.innerHTML     = getDateString(rssData[tod].day, rssData[tod].month);	
	dateTxt2.innerHTML    = tod_name[rssData[tod].tod];	
	userSettings.SetUpdateTimer();		
}

ParseXML = function(xmlData)
{
	rssData.length = 0;
	var itemlist = xmlData.getElementsByTagName("FORECAST");
	if(itemlist.length > 0){					
			var dom;				
			for(var i=0;  i< itemlist.length && i<5; i++){
				dom = itemlist.item(i);
				var forecast = new Object();
				
				forecast.day = dom.getAttribute("day");
				forecast.month = dom.getAttribute("month");
				forecast.year = dom.getAttribute("year");
				forecast.hour = dom.getAttribute("hour");
				forecast.tod = dom.getAttribute("tod");
				forecast.weekday = dom.getAttribute("weekday");
							
				forecast.cloudiness = dom.getElementsByTagName("PHENOMENA").item(0).getAttribute("cloudiness");
				forecast.precipitation = dom.getElementsByTagName("PHENOMENA").item(0).getAttribute("precipitation");
				forecast.rpower = dom.getElementsByTagName("PHENOMENA").item(0).getAttribute("rpower");
				
				forecast.maxPRESSURE = dom.getElementsByTagName("PRESSURE").item(0).getAttribute("max");
				forecast.minPRESSURE = dom.getElementsByTagName("PRESSURE").item(0).getAttribute("min");
				
				forecast.maxTEMP = dom.getElementsByTagName("TEMPERATURE").item(0).getAttribute("max");
				forecast.minTEMP = dom.getElementsByTagName("TEMPERATURE").item(0).getAttribute("min");		
				rssData[i] = forecast;
								
			}
	}		
}


function scroll_Left() {
	if (bUpdating) return;
	
	currentTOD--;	
	if (currentTOD == 0) document.getElementById('leftBtn').style.visibility = "hidden";
	document.getElementById('rightBtn').style.visibility = "visible";
	updateIdlePage(currentTOD);			
}

function scroll_Right() {
	if (bUpdating) return;
	
	currentTOD++;	
	if (currentTOD == 3) document.getElementById('rightBtn').style.visibility = "hidden";		
	document.getElementById('leftBtn').style.visibility = "visible";
	updateIdlePage(currentTOD);	
}

timeout = function(req) {
	hidePopup('refresh');			
	bUpdating = false;
	
	if (req.readyState!= 4) {
		req.onreadystatechange = function() {};
		req.abort();
		showNetworkError();		
		return;
	}
	
	try	
	{
		window.widget.error.notify(2);			
	} catch(e) {}		
}

function getDateString(date, mon, day)
{
	var months = new Array("Янв.","Фев.","Март","Апр.","Май","Июнь","Июль", "Авг.","Сент.","Окт.","Ноя.","Дек.");
	var day = new Array("Пнд.","Втр.","Срд.","Чтв.","Птц.","Суб.","Вск.");

   return day, months[mon-1]+" "+date;    
}

function getAverageTEMP(temp1, temp2) {
	var temp = (Number(temp1)+Number(temp2))/2;
	if (temp>0) return "+"+temp;
	else if (temp<=0) return temp;
	
}

function getTEMPtext(temp1, temp2) {
	var tmp = "";
	if (temp1>0) tmp="+"+temp1;
	else if (temp1<=0) tmp = ""+temp1;

    if (temp2>0) tmp += "  +"+temp2;
	else if (temp2<=0) tmp +="  "+temp2;	                           

	return tmp;
}

function getXmlDOM(xmlval) {
	var xmlDoc = null;
	
	if(window.DOMParser) {
		var parser = new DOMParser();
		xmlDoc= parser.parseFromString(xmlval,"text/xml");		
	} else if(window.ActiveXObject) {
		xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
		xmlDoc.async = "false";
		xmlDoc.loadXML(xmlval);
	} else {
		return null;
	}
	return xmlDoc;
}	

function cancel()
{
	hidePopup('refresh');	
	bUpdating = false;	
	clearTimeout(timerID);
	timerID= null;
	
	if (runningRequest.readyState >0 && runningRequest.readyState < 4) {
		runningRequest.onreadystatechange = function() {};
		runningRequest.abort();		
	}
	
	try	{
		window.widget.error.notify(1);
	} catch(E) {}			
}
